if extra.big == nil or extra.small == nil then
  error("No pieces set.")
end

local tab = {3, 3, 5, 2, 1, 1, 1, 20, 3, 9, 11, 4, 16, 9, 17, 5, 12, 11, 11, 2, 16, 6, 7, 13, 5, 2, 3, 13, 5, 3, 16, 7, 11, 6, 4, 16, 1, 9, 5, 15, 10, 11, 1, 14, 4, 16, 8, 2, 4, 5, 4, 7, 5}
local function get_tab(x)
  return tab[(x % #tab) + 1]
end

local big_wanted = 0;
location.std.generators[1].dynamic = function(ct)
  if big_wanted > 0 then
    big_wanted = big_wanted - 1
    return extra.big
  end
end
local small_wanted = 0;
location.std.generators[2].dynamic = function(ct)
  if small_wanted > 0 then
    small_wanted = small_wanted - 1
    return extra.small
  end
end

local want_big = coroutine.wrap(function()
  local idx = 0
  while true do
    coroutine.yield(true)
    for i = 1,get_tab(idx) do
      coroutine.yield(false)
    end
    idx = idx + 1
  end
end)
local want_small = coroutine.wrap(function()
  local idx = 25
  while true do
    coroutine.yield(true)
    for i = 1,get_tab(idx) do
      coroutine.yield(false)
    end
    idx = idx + 1
  end
end)
game:each_step(function()
  if want_big() then
    big_wanted = big_wanted + 1
  end
  if want_small() then
    small_wanted = small_wanted + 1
  end
end)
