local function interactions_for_spec(spec, part)
  local grid = {}
  for i,v in pairs(spec) do
    grid_store(grid, Vector.new(i - 1, 0), part)
    if v == 1 then
      grid_store(grid, Vector.new(i - 1, 1), part)
    end
  end
  return fully_connected_object_interactions(grid)
end
local function blocks_in_spec(spec)
  local ret = 0;
  for i,v in pairs(spec) do
    ret = ret + v + 1
  end
  return ret
end
local blocks_unlocked = 0
location.std.generators[1].dynamic = function(ct)
  return interactions_for_spec(get_spec(ct), 1)
end
location.std.generators[2].dynamic = function(ct)
  if blocks_unlocked > 0 then
    blocks_unlocked = blocks_unlocked - 1
    return {Place.new(CellView.new(Vector.new(0, 0)), Basic.new(2))}
  else
    return {Destroy.new(Vector.new(0, 0))}
  end
end
location.std.checkers[1].dynamic = function(ct)
  if ct > 0 then
    blocks_unlocked = blocks_unlocked + blocks_in_spec(get_spec(ct - 1))
  end
  return interactions_for_spec(get_spec(ct), 1)
end
location.std.checkers[2].dynamic = function(ct)
  return interactions_for_spec(get_spec(ct), 2)
end

local specifications =
{{1, 0, 0, 1, 1, 0, 0, 1},
{0, 0, 1, 1, 1, 0, 0, 0},
{0, 1, 0, 1, 0, 1, 1, 1},
{0, 0, 0, 1, 0, 0, 1, 1},
{1, 0, 0, 0, 0, 1, 1, 0},
{0, 1, 1, 1, 1, 1, 0, 0},
{0, 0, 1, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 0, 0, 0, 0},
{1, 0, 0, 1, 0, 0, 0, 1},
{0, 0, 1, 1, 0, 0, 1, 0},
{1, 1, 0, 1, 1, 1, 0, 1},
{1, 1, 1, 0, 0, 0, 0, 0},
{0, 0, 1, 1, 0, 0, 1, 0},
{1, 0, 1, 1, 0, 0, 1, 0},
{1, 0, 1, 1, 1, 1, 1, 1},
{1, 1, 1, 1, 1, 1, 0, 1},
{0, 0, 1, 0, 1, 0, 1, 0},
{0, 1, 0, 0, 0, 1, 0, 1},
{1, 1, 1, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 0, 1, 0, 0},
{1, 1, 0, 0, 1, 0, 0, 1},
{0, 0, 1, 1, 0, 0, 0, 1},
{0, 1, 1, 1, 0, 1, 1, 1},
{0, 0, 1, 0, 1, 1, 1, 0},
{1, 1, 0, 0, 0, 0, 0, 1},
{1, 0, 1, 0, 0, 0, 0, 1},
{0, 1, 0, 1, 0, 1, 1, 1},
{1, 0, 1, 0, 0, 0, 0, 1},
{0, 0, 1, 1, 0, 0, 1, 0},
{0, 0, 0, 1, 1, 0, 1, 0},
{0, 1, 0, 1, 0, 1, 1, 0},
{0, 1, 0, 0, 0, 1, 1, 1},
{0, 1, 0, 1, 0, 0, 1, 1},
{1, 0, 1, 1, 1, 0, 0, 0},
{1, 0, 0, 1, 1, 1, 0, 1},
{1, 1, 0, 0, 1, 1, 0, 1},
{1, 1, 0, 1, 0, 0, 0, 0},
{1, 0, 1, 0, 0, 1, 1, 0},
{1, 1, 0, 1, 0, 1, 0, 0},
{1, 0, 1, 1, 1, 0, 0, 0},
{1, 0, 0, 1, 0, 0, 1, 0},
{0, 1, 1, 0, 0, 0, 0, 0},
{0, 1, 1, 0, 0, 1, 1, 1},
{0, 0, 1, 1, 0, 0, 0, 1},
{1, 1, 0, 0, 0, 1, 0, 0},
{0, 1, 0, 0, 1, 1, 0, 0},
{0, 1, 0, 0, 0, 0, 0, 1},
{0, 1, 0, 0, 0, 0, 0, 1},
{1, 0, 0, 1, 0, 0, 1, 1},
{0, 1, 0, 0, 1, 0, 0, 0},
{0, 0, 0, 1, 0, 1, 0, 1},
{1, 0, 0, 0, 1, 0, 1, 0},
{1, 0, 1, 0, 1, 1, 0, 1},
{0, 0, 0, 1, 1, 1, 0, 0},
{0, 0, 1, 1, 1, 1, 0, 0},
{1, 1, 1, 1, 1, 1, 1, 0},
{0, 0, 1, 1, 1, 0, 0, 0},
{1, 1, 1, 1, 1, 0, 1, 0},
{0, 0, 1, 0, 1, 0, 1, 0},
{0, 0, 1, 1, 0, 1, 1, 0},
{1, 0, 1, 1, 1, 1, 1, 0},
{1, 1, 0, 1, 0, 0, 1, 0},
{1, 0, 1, 1, 1, 0, 0, 1},
{0, 1, 0, 0, 0, 1, 0, 0},
{0, 0, 0, 0, 1, 1, 0, 0},
{0, 1, 1, 0, 1, 1, 0, 0},
{0, 0, 0, 0, 0, 0, 0, 0},
{0, 1, 1, 0, 0, 0, 0, 0},
{0, 0, 1, 0, 0, 0, 0, 0},
{0, 1, 1, 1, 0, 1, 0, 1},
{0, 1, 0, 1, 1, 0, 0, 1},
{0, 1, 0, 0, 0, 1, 0, 0},
{1, 1, 0, 1, 1, 0, 1, 1},
{1, 1, 1, 1, 1, 1, 1, 1},
{0, 1, 0, 0, 0, 1, 0, 0},
{0, 0, 1, 1, 1, 1, 0, 1},
{0, 0, 1, 0, 0, 0, 0, 1},
{1, 0, 1, 1, 0, 1, 1, 0},
{0, 0, 1, 0, 1, 0, 1, 0},
{0, 0, 1, 0, 0, 0, 0, 1},
{0, 1, 0, 0, 1, 0, 1, 1},
{1, 1, 1, 1, 0, 0, 1, 1},
{0, 1, 1, 1, 1, 0, 0, 1},
{1, 0, 0, 1, 0, 0, 1, 0},
{0, 1, 1, 1, 1, 0, 1, 0},
{0, 0, 0, 1, 1, 1, 0, 1},
{0, 1, 1, 0, 0, 1, 1, 0},
{1, 1, 0, 0, 0, 0, 1, 0},
{1, 0, 1, 0, 0, 1, 1, 0},
{0, 0, 1, 1, 1, 1, 1, 0},
{1, 0, 1, 1, 1, 0, 0, 1},
{1, 1, 1, 1, 0, 1, 1, 1},
{0, 0, 0, 1, 0, 1, 0, 0},
{0, 0, 0, 1, 0, 0, 1, 0},
{1, 1, 0, 0, 1, 0, 0, 1},
{1, 1, 1, 0, 1, 0, 0, 0},
{0, 1, 0, 0, 1, 0, 0, 1},
{1, 1, 1, 0, 1, 0, 0, 1},
{1, 1, 1, 0, 1, 1, 0, 1},
{1, 1, 1, 1, 1, 1, 0, 0}}
function get_spec(n)
  return specifications[(n % #specifications) + 1]
end
